/*  Name:
 *  PennKey:
 *  Execution: N/A, this class is meant to be used by other classes
 *
 *  A class that represents a target to be hit in
 *  Furious Flying Fish. Can update its own position based
 *  on velocity and time.
 */

public class Target {

    // variables for width and height of screen
    private double width, height;

    // Position and radius
    private double xPos, yPos, radius;

    // Velocity components
    private double xVel, yVel;

    /**
     * When a target's hit points reach zero,
     * it has been destroyed by the Fish.
     */
    private int hitPoints;

    // Track if target has been hit this shot.
    private boolean hitThisShot;

    /**
     * Given a position, a radius, a velocity, and a number of hit points,
     * construct a Target.
     */
    public Target(double width, double height, double xPos, double yPos,
            double radius, double xVel, double yVel, int hitPoints) {
        // TODO
    }

    /**
     * Draw a circle centered at the target's position
     * with a radius equal to the target's radius.
     * Only draw a Target if it has more than zero
     * hit points.
     */
    public void draw() {
        // TODO
    }

    /**
     * Given the change in time, update the target's
     * position based on its x and y velocity. When
     * a target is completely offscreen horizontally,
     * its position should wrap back around to the opposite
     * horizontal side. For example, if the target moves off the
     * right side of the screen, its xPos should be set to the
     * left side of the screen minus the target's radius.
     * The same logic should apply to the target's vertical
     * position with respect to the vertical screen boundaries.
     */
    public void update(double timeStep) {
        // TODO
    }

    // Decrement the target's hit points by 1.
    public void decreaseHP() {
        --hitPoints;
    }

    /**
     * Setter function for whether or not target hit this round.
     */
    public void setHitThisShot(boolean hit) {
        // TODO
    }

    /**
     * Return whether or not this target is hit this round.
     */
    public boolean isHit() {
        // TODO
        return false;
    }

    /**
     * Getter functions that return a copy of the
     * indicated member variable.
     */
    public int getHitPoints() {
        return hitPoints;
    }

    public double getXPos() {
        return xPos;
    }

    public double getYPos() {
        return yPos;
    }

    public double getRadius() {
        return radius;
    }

}
